### Method

# EDataServer Source get_last_credentials_required_arguments_finish

since: 3.16

#### Declaration [src]

    gboolean
    e_source_get_last_credentials_required_arguments_finish (
      ESource* source,
      GAsyncResult* result,
      ESourceCredentialsReason* out_reason,
      gchar** out_certificate_pem,
      GTlsCertificateFlags* out_certificate_errors,
      GError** out_op_error,
      GError** error
    )

#### Description [src]

Finishes the operation started with e_source_get_last_credentials_required_arguments(). See `e_source_get_last_credentials_required_arguments_sync()` for more information about the output arguments.

If an error occurs, the function sets `error` and returns `FALSE`.

Available since: 3.16

#### Parameters

`result`

  Type: `GAsyncResult`

  A `GAsyncResult`.

  The data is owned by the caller of the method.

`out_reason`

  Type: `ESourceCredentialsReason`

  An `ESourceCredentialsReason`, why the credentials are required.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`out_certificate_pem`

  Type: `gchar**`

  PEM-encoded secure connection certificate, or an empty string.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`out_certificate_errors`

  Type: `GTlsCertificateFlags`

  A bit-or of `GTlsCertificateFlags` for secure connection certificate.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`out_op_error`

  Type: `GError`

  A `GError` with a description of the previous credentials error.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` on error.